#include <iostream>

using namespace std;

bool b[200000];

main ()

{
    int n,k;

    cin >> n; cin >>k;

    int a[200000];

    bool p = true;

    for (int i=0; i<n; i++)

        {  cin >> a[i];  if (a[i]!=1) { if (a[i]!=0) p=false;       } }


   if (p==true)
   {



    for (int i=0; i<n; i++)
    {
        if (k==0) break;

        if (a[i]==1) { b[i]=true; k--;}

        if (k==0) break;
    }


    if (k!=0)
    for (int i=0; i<n; i++)
    {
        if (k==0) break;

        if (a[i]==0) { b[i]=true; k--;}

        if (k==0) break;
    }
        for (int i=0; i<n; i++)
            if (b[i]==false) cout << a[i] << " ";

   }

   else
    if (k==1)


      {


      bool g = false;
       for (int i=1; i<n; i++)
       {
           if (a[i]<a[i-1]) { g=true; b[i-1]=true; }
           if (g==true) break;

       }

       if (g==false)
       for (int i=1; i<n; i++)
           {


           if (a[i]==a[i-1])
           {
               int m = 1; int in = i;
               for (int j=i; j<n; j++)
               {
                   if (a[j]>m) { m=a[j]; in=j; }
               }
              g=true;
              b[in]=false;

           }
           if (g==false)
           {
              int m = 1; int in = i;
               for (int j=i; j<n; j++)
               {
                   if (a[j]>m) { m=a[j]; in=j; }
               }
              b[in]=false;
              g=true;
           }
           if (g==true) break;
       }



       for (int64_t i=0; i<n; i++)
         if (b[i]==false) cout << a[i] << " ";
   }
}